/*
 WARNING ! This file is automatically generated !
 Do not modify. Check all the m4 files in f-cpu/configuration
 for the original definitions.

 * compiled by USER = root on HOSTNAME = localhost.localdomain
 * DATE = Fri Jul 19 13:11:38 CEST 2002
 * PWD = /fcpu/jws/f-cpu/configuration

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------
*/

#ifndef FCPU_FEATURES_H
#define FCPU_FEATURES_H

/*

source : f-cpu/configuration/f-cpu_features.h.in
destination : f-cpu/include/f-cpu_features.h
included by f-cpu/include/f-cpu_config.h

created Sat Jul 14 23:26:36 2001 by whygee@f-cpu.org
version Sun Aug 12 02:37:49 2001 : separated the opcodes from the other stuffs

This file is derived from opcodes.h.
i have separated the opcode value definitions from the
other definitions, it makes things look cleaner
and less confusing.

*/

#define INSTRUCTION_BIG_ENDIAN
/* when defined, the instructions are stored in big-endian
   format in memory. this means that the opcode is in byte[0]. */


/* these ones will be changed if needed,
   but the direct mode MUST remain 0 because
   it is the default behaviour. */
#define ROP2_DIRECT_MODE  0
#define ROP2_AND_MODE     1
#define ROP2_OR_MODE      2
#define ROP2_MUX_MODE     3

/* defines the condition field */
#define CONDITION_ZERO 0 /* must remain zero. */
#define CONDITION_MSB  1
#define CONDITION_LSB  2
#define CONDITION_NAN  3 /* currently unused */

/*
extract from the F-CPU manual : the ROP2 lookup table
   opcode   real code   Function  Symbolic name
     000      0001       A AND B      AND
     001      0010       A AND /B     ANDN
     010      0110       A XOR B      XOR
     011      0111       A OR B       OR
     100      1000       A NOR B      NOR
     101      1001       A XNOR B     XNOR
     110      1101       A OR /B      ORN
     111      1110       A NAND B     NAND

unsigned int ROP2_function_LUT[8];
 = {
  1, 2, 6, 7, 8, 9, 0xD, 0xE
};
*/

#define FUNCTION_AND    (0)
#define FUNCTION_ANDN   (1)
#define FUNCTION_XOR    (2)
#define FUNCTION_OR     (3)
#define FUNCTION_NOR    (4)
#define FUNCTION_XNOR   (5)
#define FUNCTION_ORN    (6)
#define FUNCTION_NAND   (7)

#define FUNCTION_VALUE_AND    (1)
#define FUNCTION_VALUE_ANDN   (2)
#define FUNCTION_VALUE_XOR    (6)
#define FUNCTION_VALUE_OR     (7)
#define FUNCTION_VALUE_NOR    (8)
#define FUNCTION_VALUE_XNOR   (9)
#define FUNCTION_VALUE_ORN    (11)
#define FUNCTION_VALUE_NAND   (14)

#endif /* EOF */
